/**Copyright or (C) or Copr. GET / ENST, Telecom-Paris, Ludovic Apvrille
*
* ludovic.apvrille AT enst.fr
*
* This software is a computer program whose purpose is to allow the
* edition of Latex documents
*
* This software is governed by the CeCILL  license under French law and
* abiding by the rules of distribution of free software.  You can  use,
* modify and/ or redistribute the software under the terms of the CeCILL
* license as circulated by CEA, CNRS and INRIA at the following URL
* "http://www.cecill.info".
*
* As a counterpart to the access to the source code and  rights to copy,
* modify and redistribute granted by the license, users are provided only
* with a limited warranty  and the software's author,  the holder of the
* economic rights,  and the successive licensors  have only  limited
* liability.
*
* In this respect, the user's attention is drawn to the risks associated
* with loading,  using,  modifying and/or developing or reproducing the
* software by the user in light of its specific status of free software,
* that may mean  that it is complicated to manipulate,  and  that  also
* therefore means  that it is reserved for developers  and  experienced
* professionals having in-depth computer knowledge. Users are therefore
* encouraged to load and test the software's suitability as regards their
* requirements in conditions enabling the security of their systems and/or
* data to be ensured and,  more generally, to use and operate it in the
* same conditions as regards security.
*
* The fact that you are presently reading this means that you have had
* knowledge of the CeCILL license and that you accept its terms.
*
* /**
* Class ConfigurationLatexEditor
* Creation: 11/06/2010
* Version 1.0
* @author Ludovic APVRILLE
* @see
*/

package ui;

import java.awt.*;
import java.io.*;

import org.w3c.dom.*;
import javax.xml.parsers.*;

import myutil.*;

/**
* Class
*
* @author Ludovic APVRILLE
* @see
*/
public class ConfigurationLatexEditor {
    
    public static String DocumentPath = "";
    public static String CompilationPath = "";
	public static String MakeCleanPath = "";
	public static String MakeUltraCleanPath = "";
    public static String PDFVizualizerPath = "";
	public static String DataPath = "";
	//public static String DefaultHeader = "";
	public static String TemplatesPath = "";
	public static String Dictionary = "";
	public static String PersonalDictionary = "";
    public static String LastOpenFile = "";
    public static boolean LastOpenFileDefined = false;
	public static Color Color0 = null;
	public static Color Color1 = null;
	public static Color Color2 = null;
	public static Color Color3 = null;
	public static Color Color4 = null;
	public static Color Color5 = null;
	public static Color Color6 = null;
	
    public static String LastWindowAttributesX="",  LastWindowAttributesY= "";
    public static String LastWindowAttributesWidth="",  LastWindowAttributesHeight= "";
    public static String LastWindowAttributesMax="";
    
    public static String fileName = "";
    
    
    public static void loadConfiguration(String _fileName) throws MalformedConfigurationException {
        fileName = _fileName;
        
        File f = new File(fileName);
        
        if (!FileUtils.checkFileForOpen(f)) {
            throw new MalformedConfigurationException("Filepb");
        }
        
        String data = FileUtils.loadFileData(f);
        
        if (data == null) {
            throw new MalformedConfigurationException("Filepb");
        }
        
        loadConfigurationFromXML(data);
    }
    
    public static void saveConfiguration() throws MalformedConfigurationException {
        int index0, index1, index2, index3;
		String tmp, tmp1, tmp2, location;
        File f = new File(fileName);
		boolean write = false;
        
        if (!FileUtils.checkFileForOpen(f)) {
            throw new MalformedConfigurationException("Filepb");
        }
        
        String data = FileUtils.loadFileData(f);
        
        if (data == null) {
            throw new MalformedConfigurationException("Filepb");
        }
        
        index0 = data.indexOf("LastOpenFile");
        
        //TraceManager.addDev("data = " + data + " ConfigurationTTool.LastOpenFile=" + ConfigurationTTool.LastOpenFile);
        
        if (index0 > -1) {
            index1 = data.indexOf('"', index0);
            if (index1 > -1) {
                index2 = data.indexOf('"', index1 + 1);
                if (index2 > -1) {
					tmp = data.substring(index2, data.length());
					data = data.substring(0, index1+1) + ConfigurationLatexEditor.LastOpenFile+ tmp;	
					//TraceManager.addDev("data = " + data);
					write = true;
					/*try {
					FileOutputStream fos = new FileOutputStream(f);
					fos.write(data.getBytes());
					fos.close();
					} catch (Exception e) {
					throw new  MalformedConfigurationException("Saving file failed");
					}*/
                }
            }
        }
		
		index0 = data.indexOf("LastWindowAttributes");
		if (index0 > -1) {
			tmp1 = data.substring(0, index0+20);
			tmp2 = data.substring(index0+20, data.length());
			index1 = tmp2.indexOf("/>");
			if (index1 > -1) {
				tmp2 = tmp2.substring(index1, tmp2.length());
				location = " x=\"" + LastWindowAttributesX;
				location += "\" y=\"" + LastWindowAttributesY;
				location += "\" width=\"" + LastWindowAttributesWidth;
				location += "\" height=\"" + LastWindowAttributesHeight;
				location += "\" max=\"" + LastWindowAttributesMax + "\" ";
				data = tmp1 + location + tmp2;
				write = true;
			}
		} else {
			index1= data.indexOf("</BEAMEREDITORCONFIGURATION>");
			if (index1 > -1) {
				location = "<LastWindowAttributes x=\"" + LastWindowAttributesX;
				location += "\" y=\"" + LastWindowAttributesY;
				location += "\" width=\"" + LastWindowAttributesWidth;
				location += "\" height=\"" + LastWindowAttributesHeight;
				location += "\" max=\"" + LastWindowAttributesMax + "\"/>\n\n";
				data = data.substring(0, index1) + location + data.substring(index1, data.length());
				write = true;
			}
		}
		
		if (write) {
			//TraceManager.addDev("Writing data=" + data); 
			try {
				FileOutputStream fos = new FileOutputStream(f);
				fos.write(data.getBytes());
				fos.close();
			} catch (Exception e) {
				throw new  MalformedConfigurationException("Saving file failed");
			}
		} else {
			TraceManager.addDev("Configuration could not be saved");
		}
		
    }
	
	public static boolean configSizeAvailable() {
		if (LastWindowAttributesX.length() == 0) {
			return false;
		}
		
		if (LastWindowAttributesY.length() == 0) {
			return false;
		}
		
		if (LastWindowAttributesWidth.length() == 0) {
			return false;
		}
		
		if (LastWindowAttributesHeight.length() == 0) {
			return false;
		}
		
		return true;
	}
    
    public static void printConfiguration() {
        TraceManager.addDev("DocumentPath: " + DocumentPath);
        TraceManager.addDev("CompilationPath: " + CompilationPath);
        TraceManager.addDev("MakeCleanPath: " + MakeCleanPath);
        TraceManager.addDev("MakeUltraCleanPath: " + MakeUltraCleanPath);
        TraceManager.addDev("PDFVizualizerPath: " + PDFVizualizerPath);
		TraceManager.addDev("DataPath: " + DataPath);
		//TraceManager.addDev("DefaultHeader: " + DefaultHeader);
		TraceManager.addDev("TemplatesPath: " + TemplatesPath);
		TraceManager.addDev("Dictionary: " + Dictionary);
		TraceManager.addDev("PersonalDictionary: " + PersonalDictionary);
		
        TraceManager.addDev("LastOpenFile: " + LastOpenFile);
		
		TraceManager.addDev("LastWindowAttributesX: " + LastWindowAttributesX);
		TraceManager.addDev("LastWindowAttributesY: " + LastWindowAttributesY);
		TraceManager.addDev("LastWindowAttributesWidth: " + LastWindowAttributesWidth);
		TraceManager.addDev("LastWindowAttributesHeight: " + LastWindowAttributesHeight);
		TraceManager.addDev("LastWindowAttributesMax: " + LastWindowAttributesMax);
		
		TraceManager.addDev("Color0: " + Color0);
		TraceManager.addDev("Color1: " + Color1);
        TraceManager.addDev("Color2: " + Color2);
		TraceManager.addDev("Color3: " + Color3);
		TraceManager.addDev("Color4: " + Color4);
		TraceManager.addDev("Color5: " + Color5);
		TraceManager.addDev("Color6: " + Color6);
    }
    
    public static void loadConfigurationFromXML(String data) throws MalformedConfigurationException {
        
        try {
            ByteArrayInputStream bais = new ByteArrayInputStream(data.getBytes());
            DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
            DocumentBuilder db = dbf.newDocumentBuilder();;
            
            // building nodes from xml String
            Document doc = db.parse(bais);
            NodeList nl;
            
            nl = doc.getElementsByTagName("DocumentPath");
            if (nl.getLength() > 0)
                DocumentPath(nl);
            nl = doc.getElementsByTagName("CompilationPath");
            if (nl.getLength() > 0)
                CompilationPath(nl);
			nl = doc.getElementsByTagName("MakeCleanPath");
            if (nl.getLength() > 0)
                MakeCleanPath(nl);
			nl = doc.getElementsByTagName("MakeUltraCleanPath");
            if (nl.getLength() > 0)
                MakeUltraCleanPath(nl);
            nl = doc.getElementsByTagName("PDFVizualizerPath");
            if (nl.getLength() > 0)
                PDFVizualizerPath(nl);
			nl = doc.getElementsByTagName("DataPath");
            if (nl.getLength() > 0)
                DataPath(nl);
			//nl = doc.getElementsByTagName("DefaultHeader");
            //if (nl.getLength() > 0)
            //    DefaultHeader(nl);
			nl = doc.getElementsByTagName("TemplatesPath");
            if (nl.getLength() > 0)
                TemplatesPath(nl);
			nl = doc.getElementsByTagName("Dictionary");
            if (nl.getLength() > 0)
                Dictionary(nl);
			nl = doc.getElementsByTagName("PersonalDictionary");
            if (nl.getLength() > 0)
                PersonalDictionary(nl);
			nl = doc.getElementsByTagName("LastOpenFile");
			if (nl.getLength() > 0)
				LastOpenFile(nl);
			nl = doc.getElementsByTagName("Color0");
			if (nl.getLength() > 0)
				Color0(nl);
			nl = doc.getElementsByTagName("Color1");
			if (nl.getLength() > 0)
				Color1(nl);	
			nl = doc.getElementsByTagName("Color2");
			if (nl.getLength() > 0)
				Color2(nl);	
			nl = doc.getElementsByTagName("Color3");
			if (nl.getLength() > 0)
				Color3(nl);	
			nl = doc.getElementsByTagName("Color4");
			if (nl.getLength() > 0)
				Color4(nl);	
			nl = doc.getElementsByTagName("Color5");
			if (nl.getLength() > 0)
				Color5(nl);	
			nl = doc.getElementsByTagName("Color6");
			if (nl.getLength() > 0)
				Color6(nl);	
        } catch (Exception e) {
            throw new MalformedConfigurationException(e.getMessage());
        }
    }
    
    private static void DocumentPath(NodeList nl) throws MalformedConfigurationException {
        try {
            Element elt = (Element)(nl.item(0));
            DocumentPath = elt.getAttribute("data");
        } catch (Exception e) {
            throw new MalformedConfigurationException(e.getMessage());
        }
    }
    
    private static void CompilationPath(NodeList nl) throws MalformedConfigurationException {
        try {
            Element elt = (Element)(nl.item(0));
            CompilationPath = elt.getAttribute("data");
        } catch (Exception e) {
            throw new MalformedConfigurationException(e.getMessage());
        }
    }
	
	private static void MakeCleanPath(NodeList nl) throws MalformedConfigurationException {
        try {
            Element elt = (Element)(nl.item(0));
            MakeCleanPath = elt.getAttribute("data");
        } catch (Exception e) {
            throw new MalformedConfigurationException(e.getMessage());
        }
    }
	
	private static void MakeUltraCleanPath(NodeList nl) throws MalformedConfigurationException {
        try {
            Element elt = (Element)(nl.item(0));
            MakeUltraCleanPath = elt.getAttribute("data");
        } catch (Exception e) {
            throw new MalformedConfigurationException(e.getMessage());
        }
    }
    
    private static void PDFVizualizerPath(NodeList nl) throws MalformedConfigurationException {
        try {
            Element elt = (Element)(nl.item(0));
            PDFVizualizerPath = elt.getAttribute("data");
        } catch (Exception e) {
            throw new MalformedConfigurationException(e.getMessage());
        }
    }     
	
	private static void DataPath(NodeList nl) throws MalformedConfigurationException {
        try {
            Element elt = (Element)(nl.item(0));
            DataPath = elt.getAttribute("data");
        } catch (Exception e) {
            throw new MalformedConfigurationException(e.getMessage());
        }
    }
	
	/*private static void DefaultHeader(NodeList nl) throws MalformedConfigurationException {
        try {
            Element elt = (Element)(nl.item(0));
            DefaultHeader = elt.getAttribute("data");
        } catch (Exception e) {
            throw new MalformedConfigurationException(e.getMessage());
        }
    }*/
	
	private static void TemplatesPath(NodeList nl) throws MalformedConfigurationException {
        try {
            Element elt = (Element)(nl.item(0));
            TemplatesPath = elt.getAttribute("data");
        } catch (Exception e) {
            throw new MalformedConfigurationException(e.getMessage());
        }
    }
	
	private static void Dictionary(NodeList nl) throws MalformedConfigurationException {
        try {
            Element elt = (Element)(nl.item(0));
            Dictionary = elt.getAttribute("data");
        } catch (Exception e) {
            throw new MalformedConfigurationException(e.getMessage());
        }
    }
	
	private static void PersonalDictionary(NodeList nl) throws MalformedConfigurationException {
        try {
            Element elt = (Element)(nl.item(0));
            PersonalDictionary = elt.getAttribute("data");
        } catch (Exception e) {
            throw new MalformedConfigurationException(e.getMessage());
        }
    }
    
    private static void LastOpenFile(NodeList nl) throws MalformedConfigurationException {
        try {
            Element elt = (Element)(nl.item(0));
            LastOpenFile = elt.getAttribute("data");
            LastOpenFileDefined = true;
        } catch (Exception e) {
            throw new MalformedConfigurationException(e.getMessage());
        }
    }
	
	private static void Color0(NodeList nl) throws MalformedConfigurationException {
        try {
            Element elt = (Element)(nl.item(0));
			String tmp = elt.getAttribute("data");
			if (tmp.length() > 0) {
				Color0 = getColor(tmp);
			}
        } catch (Exception e) {
            throw new MalformedConfigurationException(e.getMessage());
        }
    }
	
	private static void Color1(NodeList nl) throws MalformedConfigurationException {
        try {
            Element elt = (Element)(nl.item(0));
            String tmp = elt.getAttribute("data");
			if (tmp.length() > 0) {
				Color1 = getColor(tmp);
			}
        } catch (Exception e) {
            throw new MalformedConfigurationException(e.getMessage());
        }
    }
	
	private static void Color2(NodeList nl) throws MalformedConfigurationException {
        try {
            Element elt = (Element)(nl.item(0));
            String tmp = elt.getAttribute("data");
			if (tmp.length() > 0) {
				Color2 = getColor(tmp);
			}
        } catch (Exception e) {
			TraceManager.addDev("Exception in color2");
            throw new MalformedConfigurationException(e.getMessage());
        }
    }
	
	private static void Color3(NodeList nl) throws MalformedConfigurationException {
        try {
            Element elt = (Element)(nl.item(0));
            String tmp = elt.getAttribute("data");
			if (tmp.length() > 0) {
				Color3 = getColor(tmp);
			}
        } catch (Exception e) {
            throw new MalformedConfigurationException(e.getMessage());
        }
    }
	
	private static void Color4(NodeList nl) throws MalformedConfigurationException {
        try {
            Element elt = (Element)(nl.item(0));
            String tmp = elt.getAttribute("data");
			if (tmp.length() > 0) {
				Color4 = getColor(tmp);
			}
        } catch (Exception e) {
            throw new MalformedConfigurationException(e.getMessage());
        }
    }
	
	private static void Color5(NodeList nl) throws MalformedConfigurationException {
        try {
            Element elt = (Element)(nl.item(0));
            String tmp = elt.getAttribute("data");
			if (tmp.length() > 0) {
				Color5 = getColor(tmp);
			}
        } catch (Exception e) {
            throw new MalformedConfigurationException(e.getMessage());
        }
    }
	
	private static void Color6(NodeList nl) throws MalformedConfigurationException {
        try {
            Element elt = (Element)(nl.item(0));
            String tmp = elt.getAttribute("data");
			if (tmp.length() > 0) {
				Color6 = getColor(tmp);
			}
        } catch (Exception e) {
            throw new MalformedConfigurationException(e.getMessage());
        }
    }
	
	private static void LastWindowAttributes(NodeList nl) throws MalformedConfigurationException {
        try {
            Element elt = (Element)(nl.item(0));
            LastWindowAttributesX = elt.getAttribute("x");
			LastWindowAttributesY = elt.getAttribute("y"); 
			LastWindowAttributesWidth = elt.getAttribute("width");
			LastWindowAttributesHeight = elt.getAttribute("height");
			LastWindowAttributesMax = elt.getAttribute("max");
        } catch (Exception e) {
            throw new MalformedConfigurationException(e.getMessage());
        }
    }
	
	// s must be provided in rgb format as follows: r, g, b
	public static Color getColor(String s) {
		int [] colors = getColors(s);
		return new Color(colors[0], colors[1], colors[2], colors[3]);
	}
	
	public static int[] getColors(String s) {
		if (!isAColor(s)) {
			return null;
		}
		
		String[] colors = s.split(",");
		int i;
		
		for(i=0; i<colors.length; i++) {
			colors[i] = colors[i].trim();
		}
		
		int[] intcolors = new int[4];
		intcolors[3] = 255;
		try {
			for(i=0; i<colors.length; i++) {
				intcolors[i] = Integer.decode(colors[i]).intValue();
			}
		} catch (NumberFormatException e) {
			return null;
		}
		
		return intcolors;
	}
	
	public static boolean isAColor(String s) {
		//TraceManager.addDev("toto1");
		if (s == null) {
			return false;
		}
		
		//TraceManager.addDev("toto2");
		
		if (s.length() == 0) {
			return false;
		}
		
		//TraceManager.addDev("toto3");
		
		String[] colors = s.split(",");
		
		if ((colors.length <3) || (colors.length >4)) {
			return false;
		}
		
		//TraceManager.addDev("toto4");
		
		String tmp;
		for(int i=0; i<colors.length; i++) {
			try {
				tmp = colors[i].trim();
				Integer integer = Integer.decode(tmp);
			} catch (NumberFormatException e) {
				//TraceManager.addDev("toto5: " + tmp);
				return false;
			}
		}
		return true;
    }
    
} //
