/**Copyright or (C) or Copr. GET / ENST, Telecom-Paris, Ludovic Apvrille

ludovic.apvrille AT enst.fr

This software is a computer program whose purpose is to allow the
edition of Latex documents

This software is governed by the CeCILL  license under French law and
abiding by the rules of distribution of free software.  You can  use, 
modify and/ or redistribute the software under the terms of the CeCILL
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info". 

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability. 

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or 
data to be ensured and,  more generally, to use and operate it in the 
same conditions as regards security. 

The fact that you are presently reading this means that you have had
knowledge of the CeCILL license and that you accept its terms.

/**
 * Class JMenuBarLatexEditor
 * Creation: 11/06/2010
 * Version 1.0 11/06/2010
 * @author Ludovic APVRILLE
 * @see
 */

package ui;

import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;


public	class JMenuBarLatexEditor extends JMenuBar implements ActionListener	{
    
	private MainGUI mgui;
	
    //Menu
    private JMenu file, edit, latex, tool, help, view;
	private JCheckBoxMenuItem cbmi[];

    
    public JMenuBarLatexEditor(MainGUI _mgui) {
        super();
		mgui = _mgui;
        buildMenus(mgui);
    }
    
    public void addMenuItem(JMenu menu, String text, MainGUI mgui) {
        JMenuItem menuItem;
        
        menuItem = menu.add(text);
        menuItem.addMouseListener(mgui.mouseHandler);
        menuItem.addActionListener(mgui);
    }
    
    
    // Menus
    private	void buildMenus(MainGUI mgui) {
        // Main	menu
        file = new JMenu("File");
        edit = new JMenu("Edit");
		latex = new JMenu("Latex commands");
		tool = new JMenu("Tool");
		view = new JMenu("View");
        help = new JMenu("Help");
		
		 // MenuBar
        add(file);
        add(edit);
		add(latex);
        add(tool);
		add(view);
        add(help);
        
        JMenuItem menuItem;
        
        // FILE
        menuItem = file.add(mgui.actions[LEGUIAction.ACT_NEW]);
        menuItem.addMouseListener(mgui.mouseHandler);
        menuItem = file.add(mgui.actions[LEGUIAction.ACT_OPEN]);
        menuItem.addMouseListener(mgui.mouseHandler);
        menuItem = file.add(mgui.actions[LEGUIAction.ACT_SAVE]);
        menuItem.addMouseListener(mgui.mouseHandler);
		
		file.addSeparator();
		
		menuItem = file.add(mgui.actions[LEGUIAction.ACT_SAVE_ALL]);
        menuItem.addMouseListener(mgui.mouseHandler);
		
		file.addSeparator();
		
		menuItem = file.add(mgui.actions[LEGUIAction.ACT_SAVE_AS]);
        menuItem.addMouseListener(mgui.mouseHandler);
		
		file.addSeparator();
		
		menuItem = file.add(mgui.actions[LEGUIAction.ACT_CLOSE]);
        menuItem.addMouseListener(mgui.mouseHandler);
		
		file.addSeparator();
		
		menuItem = file.add(mgui.actions[LEGUIAction.ACT_LAST_OPEN]);
        menuItem.addMouseListener(mgui.mouseHandler);
		
		file.addSeparator();
        
        menuItem = file.add(mgui.actions[LEGUIAction.ACT_QUIT]);
        menuItem.addMouseListener(mgui.mouseHandler);
		
		// Edit
		
		menuItem = edit.add(mgui.actions[LEGUIAction.ACT_BACKWARD]);
        menuItem.addMouseListener(mgui.mouseHandler);
        menuItem = edit.add(mgui.actions[LEGUIAction.ACT_FORWARD]);
        menuItem.addMouseListener(mgui.mouseHandler);
        
        /*edit.addSeparator();
        
        menuItem = edit.add(mgui.actions[LEGUIAction.FIND_FRAME]);
        menuItem.addMouseListener(mgui.mouseHandler);*/
		
		edit.addSeparator();
		
		menuItem = edit.add(mgui.actions[LEGUIAction.ACT_INDENT]);
        menuItem.addMouseListener(mgui.mouseHandler);
		
		
		// Latex commands
		
		JMenu sections = new JMenu("Sections and blocks");
		latex.add(sections);
		menuItem = sections.add(mgui.actions[LEGUIAction.INSERT_SECTION]);
        menuItem.addMouseListener(mgui.mouseHandler);
		menuItem = sections.add(mgui.actions[LEGUIAction.INSERT_SUBSECTION]);
        menuItem.addMouseListener(mgui.mouseHandler);
		sections.addSeparator();
		menuItem = sections.add(mgui.actions[LEGUIAction.INSERT_BLOCK]);
        menuItem.addMouseListener(mgui.mouseHandler);
		menuItem = sections.add(mgui.actions[LEGUIAction.INSERT_ALERTBLOCK]);
        menuItem.addMouseListener(mgui.mouseHandler);
		menuItem = sections.add(mgui.actions[LEGUIAction.INSERT_EXAMPLEBLOCK]);
        menuItem.addMouseListener(mgui.mouseHandler);
		
		JMenu refs = new JMenu("References");
		latex.add(refs);
		menuItem = refs.add(mgui.actions[LEGUIAction.INSERT_LABEL]);
        menuItem.addMouseListener(mgui.mouseHandler);
		menuItem = refs.add(mgui.actions[LEGUIAction.INSERT_REFERENCE]);
        menuItem.addMouseListener(mgui.mouseHandler);
		refs.addSeparator();
		menuItem = refs.add(mgui.actions[LEGUIAction.INSERT_CITE]);
        menuItem.addMouseListener(mgui.mouseHandler);
		
		
		JMenu editLatex = new JMenu("Text format");
		latex.add(editLatex);
		menuItem = editLatex.add(mgui.actions[LEGUIAction.TEXT_BOLD]);
        menuItem.addMouseListener(mgui.mouseHandler);
		menuItem = editLatex.add(mgui.actions[LEGUIAction.TEXT_ITALICS]);
        menuItem.addMouseListener(mgui.mouseHandler);
		menuItem = editLatex.add(mgui.actions[LEGUIAction.TEXT_UNDERLINE]);
        menuItem.addMouseListener(mgui.mouseHandler);
		
		
		
		JMenu paragraphLatex = new JMenu("Paragraph");
		latex.add(paragraphLatex);
		menuItem = paragraphLatex.add(mgui.actions[LEGUIAction.ALIGN_LEFT]);
        menuItem.addMouseListener(mgui.mouseHandler);
		menuItem = paragraphLatex.add(mgui.actions[LEGUIAction.ALIGN_RIGHT]);
        menuItem.addMouseListener(mgui.mouseHandler);
		menuItem = paragraphLatex.add(mgui.actions[LEGUIAction.ALIGN_CENTER]);
        menuItem.addMouseListener(mgui.mouseHandler);
		menuItem = paragraphLatex.add(mgui.actions[LEGUIAction.ALIGN_JUSTIFY]);
        menuItem.addMouseListener(mgui.mouseHandler);
		
		JMenu enumerationLatex = new JMenu("Enumeration");
		latex.add(enumerationLatex);
		menuItem = enumerationLatex.add(mgui.actions[LEGUIAction.INSERT_ITEMIZE]);
        menuItem.addMouseListener(mgui.mouseHandler);
		menuItem = enumerationLatex.add(mgui.actions[LEGUIAction.INSERT_ENUMERATE]);
        menuItem.addMouseListener(mgui.mouseHandler);
		menuItem = enumerationLatex.add(mgui.actions[LEGUIAction.INSERT_ITEM]);
        menuItem.addMouseListener(mgui.mouseHandler);
		
		JMenu columns = new JMenu("Columns");
		latex.add(columns);
		menuItem = columns.add(mgui.actions[LEGUIAction.INSERT_COLUMNS]);
		menuItem.addMouseListener(mgui.mouseHandler);
		menuItem = columns.add(mgui.actions[LEGUIAction.INSERT_COLUMN]);
		menuItem.addMouseListener(mgui.mouseHandler);
		
		JMenu tables = new JMenu("Tables");
		latex.add(tables);
		menuItem = tables.add(mgui.actions[LEGUIAction.INSERT_TABULAR]);
		menuItem.addMouseListener(mgui.mouseHandler);
		menuItem = tables.add(mgui.actions[LEGUIAction.INSERT_HLINE]);
		menuItem.addMouseListener(mgui.mouseHandler);
		menuItem = tables.add(mgui.actions[LEGUIAction.INSERT_ROWCOLOR]);
		menuItem.addMouseListener(mgui.mouseHandler);
		
		JMenu code = new JMenu("Code");
		latex.add(code);
		menuItem = code.add(mgui.actions[LEGUIAction.INSERT_LISTING]);
		menuItem.addMouseListener(mgui.mouseHandler);
		
		JMenu figures = new JMenu("Figure");
		latex.add(figures);
		menuItem = figures.add(mgui.actions[LEGUIAction.INSERT_FIGURE]);
		menuItem.addMouseListener(mgui.mouseHandler);
		
		JMenu beamer = new JMenu("Beamer");
		latex.add(beamer);
		menuItem = beamer.add(mgui.actions[LEGUIAction.INSERT_FRAME]);
        menuItem.addMouseListener(mgui.mouseHandler);
		
		
		
		menuItem = latex.add(mgui.actions[LEGUIAction.INSERT_NOTE]);
        menuItem.addMouseListener(mgui.mouseHandler);
		
		
		// Tool
		
		menuItem = tool.add(mgui.actions[LEGUIAction.GENERATE_NOTES]);
        menuItem.addMouseListener(mgui.mouseHandler);
		
		tool.addSeparator();
		
		menuItem = tool.add(mgui.actions[LEGUIAction.ACT_COMPILE]);
        menuItem.addMouseListener(mgui.mouseHandler);
		
		tool.addSeparator();
		
		menuItem = tool.add(mgui.actions[LEGUIAction.ACT_COMPILE_ALL]);
        menuItem.addMouseListener(mgui.mouseHandler);
		
		tool.addSeparator();
		
		menuItem = tool.add(mgui.actions[LEGUIAction.ACT_MAKE_CLEAN]);
        menuItem.addMouseListener(mgui.mouseHandler);
		
		menuItem = tool.add(mgui.actions[LEGUIAction.ACT_MAKE_ULTRACLEAN]);
        menuItem.addMouseListener(mgui.mouseHandler);
		
		// View
		
		menuItem = view.add(mgui.actions[LEGUIAction.ACT_VIEW_PDF]);
        menuItem.addMouseListener(mgui.mouseHandler);
		
		menuItem = view.add(mgui.actions[LEGUIAction.ACT_VIEW_PDF_NOTES]);
        menuItem.addMouseListener(mgui.mouseHandler);
		
		JMenu dics = new JMenu("Dictionaries");
		tool.add(dics);
		
		cbmi = new JCheckBoxMenuItem[mgui.getNbOfDictionaries()];
		for(int i=0; i<cbmi.length; i++) {
			cbmi[i] = new JCheckBoxMenuItem(mgui.getDictionary(i).getName());
			cbmi[i].addActionListener(this);
			cbmi[i].setSelected(mgui.getDictionary(i).isSelected());
			dics.add(cbmi[i]);
		}
		
		// Help
		menuItem = help.add(mgui.actions[LEGUIAction.ABOUT]);
        menuItem.addMouseListener(mgui.mouseHandler);
        
       
    }
	
	 public void actionPerformed(ActionEvent evt)  {
		 for(int i=0; i<cbmi.length; i++) {
			 if (evt.getSource() == cbmi[i]) {
				 mgui.getDictionary(i).setSelected(cbmi[i].isSelected());
				 mgui.updateOnDictionaries();
				 return;
			 }
		 }
	}
	
} // Class

