/**Copyright or (C) or Copr. GET / ENST, Telecom-Paris, Ludovic Apvrille

ludovic.apvrille AT enst.fr

This software is a computer program whose purpose is to allow the
edition of Latex documents

This software is governed by the CeCILL  license under French law and
abiding by the rules of distribution of free software.  You can  use, 
modify and/ or redistribute the software under the terms of the CeCILL
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info". 

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability. 

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or 
data to be ensured and,  more generally, to use and operate it in the 
same conditions as regards security. 

The fact that you are presently reading this means that you have had
knowledge of the CeCILL license and that you accept its terms.

/**
 * Class LEGUIAction
 *
 * Creation: 11/06/2010
 * @version 1.0 11/06/2010
 * @author Ludovic APVRILLE
 * @see 
 */

package ui;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;


import javax.swing.*;

import javax.swing.event.EventListenerList;

public class LEGUIAction extends AbstractAction {
    // Actions
    public static final int ACT_NEW = 0;
    public static final int ACT_OPEN = 1;
	public static final int ACT_LAST_OPEN = 2;
    public static final int ACT_SAVE = 3;
	public static final int ACT_SAVE_AS = 4;
	public static final int ACT_SAVE_ALL = 32;
	public static final int ACT_CLOSE = 33;
	public static final int ACT_QUIT = 5;
	
	public static final int GENERATE_NOTES = 48;   
	public static final int GENERATE_CURRENT = 58;
	
	public static final int ABOUT = 6;
	
	public static final int ACT_BACKWARD = 7;
	public static final int ACT_FORWARD = 8;
	
	public static final int ACT_INDENT = 9;
	
	public static final int INSERT_ITEMIZE = 10;
	public static final int INSERT_ENUMERATE = 11;
	public static final int INSERT_ITEM = 12;
	
	public static final int ALIGN_LEFT = 13;
	public static final int ALIGN_RIGHT = 14;
	public static final int ALIGN_CENTER = 15;
	public static final int ALIGN_JUSTIFY = 16;
	public static final int TEXT_BOLD = 17;
	public static final int TEXT_ITALICS = 18;
	public static final int TEXT_UNDERLINE = 19;
	
	public static final int INSERT_FIGURE = 20;
	
	public static final int TEXT_SIZE_0 = 21;
	public static final int TEXT_SIZE_1 = 22;
	public static final int TEXT_SIZE_2 = 23;
	public static final int TEXT_SIZE_3 = 24;
	public static final int TEXT_SIZE_4 = 25;
	public static final int TEXT_SIZE_5 = 26;
	public static final int TEXT_SIZE_6 = 27;
	public static final int TEXT_SIZE_7 = 28;
	public static final int TEXT_SIZE_8 = 29;
	public static final int TEXT_SIZE_9 = 30;
	
	public static final int ACT_COMPILE_ONLY = 59;
	public static final int ACT_COMPILE = 31;
	public static final int ACT_COMPILE_ALL = 34;
	public static final int ACT_MAKE_CLEAN = 35;
	public static final int ACT_MAKE_ULTRACLEAN = 36;
	
	public static final int ACT_VIEW_PDF = 37;
	public static final int ACT_VIEW_PDF_NOTES = 49;
	public static final int ACT_VIEW_PDF_CURRENT = 57;
	
	public static final int INSERT_TEMPLATE = 38;
	
	public static final int INSERT_SECTION = 39;
	public static final int INSERT_SUBSECTION = 40;
	public static final int INSERT_REFERENCE = 41;
	public static final int INSERT_CITE = 42;
	public static final int INSERT_LABEL = 43;
	
	public static final int INSERT_BLOCK = 44;
	public static final int INSERT_ALERTBLOCK = 45;
	public static final int INSERT_EXAMPLEBLOCK = 46;
	
	public static final int INSERT_NOTE = 47;
	
	public static final int INSERT_TABULAR = 50;
	public static final int INSERT_ROWCOLOR = 51;    
	public static final int INSERT_HLINE = 52;
	
	public static final int INSERT_LISTING = 53;
	
	public static final int INSERT_COLUMNS = 54;
	public static final int INSERT_COLUMN = 55;
	
	public static final int INSERT_FRAME = 56;
	
	public static final int FIND = 60;
	public static final int FIND_PREVIOUS = 61;
	public static final int FIND_FRAME = 62;
	public static final int REPLACE_ONE = 63;
	public static final int REPLACE_ALL = 64;
	

    public static final int NB_ACTION = 65;

    private  static final LEAction [] actions = new LEAction[NB_ACTION];
    
    private EventListenerList listeners;
    
    public static final String JLF_IMAGE_DIR = "";
    
    public static final String LARGE_ICON = "LargeIcon";
    

    
    public LEGUIAction(int id) {
        if (actions[0] == null) {
            init();
        }
        if (actions[id] == null) {
            return ;
        }
        
        putValue(Action.NAME, actions[id].NAME);
        putValue(Action.SMALL_ICON, actions[id].SMALL_ICON);
        putValue(LARGE_ICON, actions[id].LARGE_ICON);
        putValue(Action.SHORT_DESCRIPTION, actions[id].SHORT_DESCRIPTION);
        putValue(Action.LONG_DESCRIPTION, actions[id].LONG_DESCRIPTION);
        //putValue(Action.MNEMONIC_KEY, new Integer(actions[id].MNEMONIC_KEY));
        if (actions[id].MNEMONIC_KEY != 0) {
            putValue(Action.ACCELERATOR_KEY, KeyStroke.getKeyStroke(actions[id].MNEMONIC_KEY, java.awt.event.InputEvent.CTRL_MASK));
        }
        putValue(Action.ACTION_COMMAND_KEY, actions[id].ACTION_COMMAND_KEY);
        
    }
    
    public void setName(int index, String name) {
        actions[index].NAME = name;
        putValue(Action.NAME, actions[index].NAME);
    }
	
	public void setShortDescription(int index, String name) {
        actions[index].SHORT_DESCRIPTION = name;
        putValue(Action.SHORT_DESCRIPTION, actions[index].SHORT_DESCRIPTION);
    }
	
	public void setLongDescription(int index, String name) {
        actions[index].LONG_DESCRIPTION = name;
        putValue(Action.LONG_DESCRIPTION, actions[index].LONG_DESCRIPTION);
    }
    
    public void init() {
		String s = ConfigurationLatexEditor.LastOpenFile;
		if (s.length() > 50) {
			s = s.substring(0, 50);
		}
        actions[ACT_NEW] = new LEAction("new-command", "New", IconManager.imgic20, IconManager.imgic21, "New", "New document", 'N');
        actions[ACT_OPEN] = new LEAction("open-command","Open", IconManager.imgic22, IconManager.imgic23, "Open", "Open an existing document",'O');
    	actions[ACT_CLOSE] = new LEAction("close-command","Close", IconManager.imgic78, IconManager.imgic78, "Close", "close an opened document",'O');
    	actions[ACT_LAST_OPEN] = new LEAction("last-open-command", "Open last presentation: " + s, IconManager.imgic22, IconManager.imgic23, "Open file: " + s, "Open the lastly saved document: " + s,'0');
    	actions[ACT_SAVE] = new LEAction("save-command", "Save",IconManager.imgic24, IconManager.imgic25, "Save", "Save a document", 'S');
		actions[ACT_SAVE_AS] = new LEAction("saveas-command", "Save as",IconManager.imgic24, IconManager.imgic25, "Save as", "Save document under a new name", '0');
		actions[ACT_SAVE_ALL] = new LEAction("saveall-command", "Save all",IconManager.imgic68, IconManager.imgic69, "Save all", "Save all documents", '0');
		actions[ACT_QUIT] = new LEAction("quit-command", "Quit", IconManager.imgic26, IconManager.imgic27, "Quit",  "Quit Latex Editor", 'Q');
		
		actions[GENERATE_NOTES] = new LEAction("gen-notes-command", "Generate notes", IconManager.imgic66, IconManager.imgic67, "Generate notes",  "Generate notes", 'M');
		
		actions[GENERATE_CURRENT] = new LEAction("gen-current-command", "Generate current", IconManager.imgic96, IconManager.imgic96, "Generate current",  "Generate current", 'L');
		
		
        actions[ABOUT] = new LEAction("About-command", "About", IconManager.imgic30, IconManager.imgic30, "About",  "About Latex Editor", '0');
        
		actions[ACT_BACKWARD] = new LEAction("backward-command", "Undo",IconManager.imgic40, IconManager.imgic41, "Undo", "One operation before", '0');
        actions[ACT_FORWARD] = new LEAction("forward-command", "Redo", IconManager.imgic42, IconManager.imgic43, "Redo", "One operation ahead", 'Y');
        
		actions[ACT_INDENT] = new LEAction("indent-command", "Indent", IconManager.imgic42, IconManager.imgic43, "Indent text", "Indent text", 'I');
        
		actions[ACT_COMPILE_ONLY] = new LEAction("compileonly-command", "Compile", IconManager.imgic90, IconManager.imgic90, "Compile",  "Compile (but do not save the model before)", 'G');
		actions[ACT_COMPILE] = new LEAction("compile-command", "Save current and compile", IconManager.imgic92, IconManager.imgic92, "Save current and compile",  "Save the current and compile", 'G');
		actions[ACT_COMPILE_ALL] = new LEAction("compile-all-command", "Save all and compile", IconManager.imgic94, IconManager.imgic94, "Save all and compile",  "Save all documents and compile the current", 'J');
		actions[ACT_MAKE_CLEAN] = new LEAction("compile-makeclean-command", "Make clean", IconManager.imgic86, IconManager.imgic87, "Make clean",  "Make clean", '0');
		actions[ACT_VIEW_PDF] = new LEAction("viewpdf-command", "View pdf", IconManager.imgic200, IconManager.imgic200, "View pdf",  "View pdf", '0');
		actions[ACT_VIEW_PDF_NOTES] = new LEAction("viewpdf-notes--command", "View pdf of notes", IconManager.imgic202, IconManager.imgic202, "View pdf of notes",  "View pdf of notes", '0');
		actions[ACT_VIEW_PDF_CURRENT] = new LEAction("viewpdf-current--command", "View pdf of current view", IconManager.imgic204, IconManager.imgic204, "View pdf of current view",  "View pdf of current view", '0');
		actions[ACT_MAKE_ULTRACLEAN] = new LEAction("compile-makeultraclean-command", "Make ultraclean", IconManager.imgic86, IconManager.imgic87, "Make ultraclean",  "Make ultraclean", '0');
		
		actions[INSERT_ITEMIZE] = new LEAction("insert-itemize-command", "Itemize", IconManager.imgic126, IconManager.imgic126, "Itemize", "Insert itemize", '0');
        actions[INSERT_ENUMERATE] = new LEAction("insert-enumerate-command", "Enumerate", IconManager.imgic130, IconManager.imgic130, "Enumerate", "Insert enumerate", '0');
        actions[INSERT_ITEM] = new LEAction("insert-item-command", "New item", IconManager.imgic128, IconManager.imgic128, "New item", "Insert a new item", '0');
		
		actions[ALIGN_LEFT] = new LEAction("align-left-command", "Align left", IconManager.imgic70, IconManager.imgic71, "Align left", "Align left", '0');
        actions[ALIGN_RIGHT] = new LEAction("align-right-command", "Align right", IconManager.imgic72, IconManager.imgic73, "Align right", "Align right", '0');
        actions[ALIGN_CENTER] = new LEAction("align-center-command", "Align center", IconManager.imgic74, IconManager.imgic75, "Align center", "Align center", '0');
        actions[ALIGN_JUSTIFY] = new LEAction("align-justify-command", "Align justify", IconManager.imgic76, IconManager.imgic77, "Align justify", "Align justify", '0');
		
		actions[TEXT_BOLD] = new LEAction("text-bold-command", "Bold", IconManager.imgic80, IconManager.imgic81, "Bold", "Bold text", '0');
        actions[TEXT_ITALICS] = new LEAction("text-italics-command", "Italics", IconManager.imgic82, IconManager.imgic83, "Italics", "Italics text", '0');
        actions[TEXT_UNDERLINE] = new LEAction("text-underline-command", "Underline", IconManager.imgic84, IconManager.imgic85, "Underline", "Underline text", '0');
		
        actions[INSERT_FIGURE] = new LEAction("insert-figure-command", "Insert figure", IconManager.imgic138, IconManager.imgic138, "Insert figure", "Insert a new figure", '0');
        
		actions[TEXT_SIZE_0] = new LEAction("insert-text0-command", "tiny", IconManager.imgic150, IconManager.imgic150, "tiny", "tiny text size", '0');
		actions[TEXT_SIZE_1] = new LEAction("insert-text1-command", "scriptsize", IconManager.imgic152, IconManager.imgic152, "scriptize", "scriptsize text size", '0');
		actions[TEXT_SIZE_2] = new LEAction("insert-text2-command", "footnotesize", IconManager.imgic154, IconManager.imgic154, "footnotesize", "footnotesize text size", '0');
		actions[TEXT_SIZE_3] = new LEAction("insert-text3-command", "small", IconManager.imgic156, IconManager.imgic156, "small", "small text size", '0');
		actions[TEXT_SIZE_4] = new LEAction("insert-text4-command", "normal", IconManager.imgic158, IconManager.imgic158, "normal", "normal text size", '0');
		actions[TEXT_SIZE_5] = new LEAction("insert-text5-command", "large", IconManager.imgic160, IconManager.imgic160, "large", "large text size", '0');
		actions[TEXT_SIZE_6] = new LEAction("insert-text6-command", "Large", IconManager.imgic162, IconManager.imgic162, "Large", "Large text size", '0');
		actions[TEXT_SIZE_7] = new LEAction("insert-text7-command", "LARGE", IconManager.imgic164, IconManager.imgic164, "LARGE", "LARGE text size", '0');
		actions[TEXT_SIZE_8] = new LEAction("insert-text8-command", "huge", IconManager.imgic166, IconManager.imgic166, "huge", "huge text size", '0');
		actions[TEXT_SIZE_9] = new LEAction("insert-text9-command", "Huge", IconManager.imgic168, IconManager.imgic168, "Huge", "Huge text size", '0');
		
		actions[INSERT_TEMPLATE] = new LEAction("insert-template", "Insert template", IconManager.imgic88, IconManager.imgic89, "Insert Template", "Insert a new template at the cursor position", '0');
		
		actions[INSERT_SECTION] = new LEAction("insert-section", "Section", IconManager.imgic104, IconManager.imgic104, "Section", "Insert a new section at the cursor position", '0');
		actions[INSERT_SUBSECTION] = new LEAction("insert-subsection", "Subsection", IconManager.imgic106, IconManager.imgic106, "Subsection", "Insert a new subsection at the cursor position", '0');
		actions[INSERT_REFERENCE] = new LEAction("insert-ref", "Reference", IconManager.imgic176, IconManager.imgic176, "Reference", "Insert a reference to a label", '0');
		actions[INSERT_CITE] = new LEAction("insert-cite", "Citation", IconManager.imgic178, IconManager.imgic178, "Citation", "Insert a citation to bibtex element", '0');
		actions[INSERT_LABEL] = new LEAction("insert-label", "Label", IconManager.imgic180, IconManager.imgic180, "Label", "Insert a label at current cursor position", '0');
		
		actions[INSERT_BLOCK] = new LEAction("insert-block", "Block", IconManager.imgic132, IconManager.imgic132, "Block", "Insert a block at current cursor position", '0');
		actions[INSERT_ALERTBLOCK] = new LEAction("insert-alertblock", "Alert block", IconManager.imgic134, IconManager.imgic134, "Alert block", "Insert an alert block at current cursor position", '0');
		actions[INSERT_EXAMPLEBLOCK] = new LEAction("insert-exampleblock", "Example block", IconManager.imgic136, IconManager.imgic136, "Example block", "Insert an example block at current cursor position", '0');
		
		actions[INSERT_NOTE] = new LEAction("insert-note", "Note", IconManager.imgic140, IconManager.imgic140, "Note", "Insert a note at current cursor position", '0');
		
		actions[INSERT_COLUMNS] = new LEAction("insert-columns-command", "Columns", IconManager.imgic122, IconManager.imgic122, "Columns", "Insert columns", '0');
        actions[INSERT_COLUMN] = new LEAction("insert-column-command", "New column", IconManager.imgic124, IconManager.imgic124, "New column", "Insert a new column", '0');
        
		actions[INSERT_LISTING] = new LEAction("insert-listing-command", "Insert program code", IconManager.imgic142, IconManager.imgic142, "Insert program code", "Insert a program code in Latex format", '0');
        
		actions[INSERT_TABULAR] = new LEAction("insert-tabular-command", "Tabular", IconManager.imgic170, IconManager.imgic170, "Tabular", "Insert a new Latex table (\\begin{tabular) ...", '0');
        actions[INSERT_ROWCOLOR] = new LEAction("insert-rowcolor-command", "Row color", IconManager.imgic172, IconManager.imgic172, "Row color", "Set a row color (\\rowcolor)", '0');
        actions[INSERT_HLINE] = new LEAction("insert-hline-command", "New table line (hline)", IconManager.imgic174, IconManager.imgic174, "New table line (hline)", "Insert a new table line (hline)", '0');
        
		actions[INSERT_FRAME] = new LEAction("insert-frame-command", "Frame", IconManager.imgic100, IconManager.imgic100, "Frame", "Insert a new frame in Latex format", '0');
        
		actions[FIND] = new LEAction("find-next-command", "", IconManager.imgic52, IconManager.imgic53, "Find next", "Reach next element to search for", 'F');
        actions[FIND_PREVIOUS] = new LEAction("find-previous-command", "", IconManager.imgic54, IconManager.imgic55, "Find previous", "Reach previous element to search for", 'P');
        actions[FIND_FRAME] = new LEAction("find-frame-command", "", IconManager.imgic148, IconManager.imgic148, "Find", "Find dialog window", 'P');
        actions[REPLACE_ONE] = new LEAction("replace-one-command", "Replace one", IconManager.imgic146, IconManager.imgic146, "Replace one", "Replace one occurence under cursor position", 'P');
        actions[REPLACE_ALL] = new LEAction("replace-all-command", "Replace all", IconManager.imgic146, IconManager.imgic146, "Replace all", "Replace all occurences starting at cursor position", 'P');
        
    }
    
    
    public String getActionCommand()  {
        return (String)getValue(Action.ACTION_COMMAND_KEY);
    }

    public String getShortDescription()  {
        return (String)getValue(Action.SHORT_DESCRIPTION);
    }
    
    public String getLongDescription()  {
        return (String)getValue(Action.LONG_DESCRIPTION);
    }

    public void actionPerformed(ActionEvent evt)  {
        //System.out.println("Action performed");
        if (listeners != null) {
            Object[] listenerList = listeners.getListenerList();
            
            // Recreate the ActionEvent and stuff the value of the ACTION_COMMAND_KEY
            ActionEvent e = new ActionEvent(evt.getSource(), evt.getID(),
            (String)getValue(Action.ACTION_COMMAND_KEY));
            for (int i = 0; i <= listenerList.length-2; i += 2) {
                ((ActionListener)listenerList[i+1]).actionPerformed(e);
            }
        }
    }
    
    public void addActionListener(ActionListener l)  {
        if (listeners == null) {
            listeners = new EventListenerList();
        }
        listeners.add(ActionListener.class, l);
    }
    
    public void removeActionListener(ActionListener l)  {
        if (listeners == null) {
            return;
        }
        listeners.remove(ActionListener.class, l);
    }    
}
