/**Copyright or (C) or Copr. GET / ENST, Telecom-Paris, Ludovic Apvrille

ludovic.apvrille AT enst.fr

This software is a computer program whose purpose is to allow the
edition of Latex documents

This software is governed by the CeCILL  license under French law and
abiding by the rules of distribution of free software.  You can  use, 
modify and/ or redistribute the software under the terms of the CeCILL
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info". 

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability. 

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or 
data to be ensured and,  more generally, to use and operate it in the 
same conditions as regards security. 

The fact that you are presently reading this means that you have had
knowledge of the CeCILL license and that you accept its terms.

/**
 * Class DiagramTreeRenderer
 * Icons and tooltiptext for the main tree
 * Creation: 11/06/2010
 * Version 1.0 11/06/2010
 * @author Ludovic APVRILLE
 * @see
 */

package ui.tree;

import java.awt.*;
import javax.swing.*;
import javax.swing.tree.*;

import latexstructure.*;
import ui.*;


public class DiagramTreeRenderer extends DefaultTreeCellRenderer  {
    
    public DiagramTreeRenderer() {
        
    }
    
    public Component getTreeCellRendererComponent(
    JTree tree,
    Object value,
    boolean sel,
    boolean expanded,
    boolean leaf,
    int row,
    boolean hasFocus) {
        
        super.getTreeCellRendererComponent(
        tree, value, sel,
        expanded, leaf, row,
        hasFocus);
		
		//System.out.println("value=" + value.getClass());
        
        /*if (value instanceof BeamerSlide) {
			setIcon(IconManager.imgic100);
			setToolTipText("Slide");
        } else if (value instanceof BeamerRawSlide) {
			if (((BeamerRawSlide)value).isAFrameTitle()) {
				setIcon(IconManager.imgic110);
				setToolTipText("Frame title");
			} else {
				setIcon(IconManager.imgic100);
				setToolTipText("Raw slide");
			}
		} else if (value instanceof BeamerOutline) {
			setIcon(IconManager.imgic102);
            setToolTipText("Outline");
		} else if (value instanceof BeamerRawOutline) {
			setIcon(IconManager.imgic102);
            setToolTipText("Raw outline");
		} else if (value instanceof BeamerCommand) {
			setIcon(IconManager.imgic108);
            setToolTipText("Command");
		} else if (value instanceof BeamerSection) {
			setIcon(IconManager.imgic104);
            setToolTipText("Section");
		} else if (value instanceof BeamerSubsection) {
			setIcon(IconManager.imgic106);
            setToolTipText("Subsection");*/
		if (value instanceof LatexElement) {
			LatexElement le = (LatexElement)value;
			setIcon(le.getIcon());
			setToolTipText(le.getTreeToolTip());
			/*if (le.getType() == 2) {
				setIcon(IconManager.imgic108);
				setToolTipText("Biblio");
			} else if (le.getType() == 3) {
				setIcon(IconManager.imgic102);
				setToolTipText("Abstract");
			} else if (le.getType() == 4) {
				setIcon(IconManager.imgic110);
				setToolTipText("Title");
			} else if (le.getType() == 7) {
				setIcon(IconManager.imgic104);
				setToolTipText("Section");
			} else if (le.getType() == 8) {
				setIcon(IconManager.imgic106);
				setToolTipText("Subsection");
			} else if (le.getType() == 9) {
				setIcon(IconManager.imgic106);
				setToolTipText("Subsubsection");
			} else {
				setIcon(IconManager.imgic108);
				setToolTipText("Other element");
			}*/
			
		} else {
			setIcon(IconManager.imgic114);
            setToolTipText("Latex Presentation");
        } 
 
        
        return this;
    }
}
