/**Copyright or (C) or Copr. GET / ENST, Telecom-Paris, Ludovic Apvrille

ludovic.apvrille AT enst.fr

This software is a computer program whose purpose is to allow the 
edition of TURTLE analysis, design and deployment diagrams, to 
allow the generation of RT-LOTOS or Java code from this diagram, 
and at last to allow the analysis of formal validation traces 
obtained from external tools, e.g. RTL from LAAS-CNRS and CADP 
from INRIA Rhone-Alpes.

This software is governed by the CeCILL  license under French law and
abiding by the rules of distribution of free software.  You can  use, 
modify and/ or redistribute the software under the terms of the CeCILL
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info". 

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability. 

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or 
data to be ensured and,  more generally, to use and operate it in the 
same conditions as regards security. 

The fact that you are presently reading this means that you have had
knowledge of the CeCILL license and that you accept its terms.

/**
* Class JFrameFind
* Creation: 04/01/2012
* version 1.0 04/01/2012
* @author Ludovic APVRILLE
* @see
*/

package ui.window;

//import java.io.*;
import javax.swing.*;
//import javax.swing.event.*;
import javax.swing.table.*;
import java.awt.*;
import java.awt.event.*;
//import java.util.*;


import myutil.*;
import ui.*;


public	class JFrameFind extends JFrame implements ActionListener {
	
	private static final int GAP    = 5;
	
	public static int opened = 0;
	private static boolean matchSelected = false;
	
    //private JScrollPane jsp;
    private JTextField find;
    private JTextField replace;
	
	private JCheckBox caseNonDependent;
	
    protected JButton close;
    
    private MainGUI mgui;

    public JFrameFind(String title, MainGUI _mgui) {
    	super(title);
    		if (opened > 0) {
    			dispose();
    			return;
    		}
    		opened ++;
        mgui = _mgui;
        makeComponents();
    }
    
    public void makeComponents() {
        setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
        Container framePanel = getContentPane();
        framePanel.setLayout(new BorderLayout());
        
		
        // Close Button
        JPanel jp = new JPanel();
        close = new JButton("Close", IconManager.imgic27);
        close.addActionListener(this);
        jp.add(close);
        framePanel.add(jp, BorderLayout.SOUTH);
        
		// Other inputs
		// Inputs from user
		
		
		JPanel panel2 = new JPanel(new BorderLayout());
		
		JPanel jp2 = new JPanel(new GridBagLayout());
		GBHelper pos = new GBHelper();
		jp2.setBorder(new javax.swing.border.TitledBorder("Find"));
		
		//jp2.add(new Gap(GAP), pos);
		jp2.add(new JLabel("Find:"), pos.nextCol().align(GridBagConstraints.EAST));
        //jp2.add(new Gap(GAP), pos.nextCol());
        find = new JTextField(20);
         jp2.add(find, pos.nextCol().align(GridBagConstraints.CENTER).width(3).expandW());
         jp2.add(new Gap(GAP), pos.nextCol(3));
		jp2.add(new JButton(mgui.actions[LEGUIAction.FIND_PREVIOUS]), pos.nextCol());
		
         //jp2.add(new Gap(GAP), pos.nextRow());
		caseNonDependent = new JCheckBox("Match case");
		caseNonDependent.setSelected(matchSelected);
		jp2.add(caseNonDependent, pos.nextRow().align(GridBagConstraints.WEST).width(3).expandW());
		 jp2.add(new Gap(GAP), pos.nextCol(5));
		jp2.add(new JButton(mgui.actions[LEGUIAction.FIND]), pos.nextCol());
		
		jp2.add(new Gap(GAP), pos.nextRow());
		
		/*GridBagLayout gridbag0 = new GridBagLayout();
        GridBagConstraints c0 = new GridBagConstraints();
		jp2.setLayout(gridbag0);
		c0.gridwidth = 1;
        c0.gridheight = 1;
        c0.weighty = 1.0;
        c0.weightx = 1.0;
		jp2.setBorder(new javax.swing.border.TitledBorder("Find"));
		JLabel label = new JLabel("Find:");
		jp2.add(label, c0);
		c0.gridwidth = GridBagConstraints.REMAINDER; //end row
		find = new JTextField("", 20);
		jp2.add(find, c0);
		/*c0.gridwidth = 1;
		label = new JLabel("Replace:");
		jp2.add(label, c0);
		replace = new JTextField("", 20);
		jp2.add(replace, c0);
		caseNonDependent = new JCheckBox("Match case");
		caseNonDependent.setSelected(matchSelected);
		jp2.add(caseNonDependent, c0);
		c0.gridwidth = GridBagConstraints.REMAINDER; //end row
		label = new JLabel(" ");
		jp2.add(label, c0);*/
		panel2.add(jp2, BorderLayout.NORTH);
		
		
		
		/*jp = new JPanel();
		gridbag0 = new GridBagLayout();
        c0 = new GridBagConstraints();
		jp.setLayout(gridbag0);
		c0.gridwidth = 1;
        c0.gridheight = 1;
        c0.weighty = 1.0;
        c0.weightx = 1.0;
		
		jp.setBorder(new javax.swing.border.TitledBorder("Actions on graph"));
		
		c0.gridwidth = 1;
		label = new JLabel("System information action:");
		jp.add(label, c0);
		infoText = new JTextField("systemInfo", 20);
		jp.add(infoText, c0);
		c0.gridwidth = GridBagConstraints.REMAINDER; //end row
		label = new JLabel(" (not case sensitive)");
		jp.add(label, c0);
		
		c0.gridwidth = 1;
		label = new JLabel("Time elapsed action:");
		jp.add(label, c0);
		tickInfoText = new JTextField("goTS", 20);
		jp.add(tickInfoText, c0);
		c0.gridwidth = GridBagConstraints.REMAINDER; //end row
		label = new JLabel(" (not case sensitive)");
		jp.add(label, c0);
		
		c0.gridwidth = 1;
		label = new JLabel("Core information action:");
		jp.add(label, c0);
		coreInfoText = new JTextField("printCoreStates", 20);
		jp.add(coreInfoText, c0);
		c0.gridwidth = GridBagConstraints.REMAINDER; //end row
		label = new JLabel(" (not case sensitive)");
		jp.add(label, c0);
		
		c0.gridwidth = 1;
		label = new JLabel("Task information action:");
		jp.add(label, c0);
		taskInfoText = new JTextField("taskInfo", 20);
		jp.add(taskInfoText, c0);
		c0.gridwidth = GridBagConstraints.REMAINDER; //end row
		label = new JLabel(" (not case sensitive)");
		jp.add(label, c0);
		
		panel2.add(jp, BorderLayout.CENTER);
		
		jp = new JPanel();
		gridbag0 = new GridBagLayout();
        c0 = new GridBagConstraints();
		jp.setLayout(gridbag0);
		c0.gridwidth = 1;
        c0.gridheight = 1;
        c0.weighty = 1.0;
        c0.weightx = 1.0;
		
		jp.setBorder(new javax.swing.border.TitledBorder("Power consumption"));
		
		c0.gridwidth = 1;
		label = new JLabel("LOW mode:");
		jp.add(label, c0);
		pcInLowMode = new JTextField("100", 20);
		jp.add(pcInLowMode, c0);
		c0.gridwidth = GridBagConstraints.REMAINDER; //end row
		label = new JLabel("pw / clock cycle");
		jp.add(label, c0);
		
		c0.gridwidth = 1;
		label = new JLabel("LOW to HIGH mode:");
		jp.add(label, c0);
		pcInLowToHighMode = new JTextField("140", 20);
		jp.add(pcInLowToHighMode, c0);
		c0.gridwidth = GridBagConstraints.REMAINDER; //end row
		label = new JLabel("pw / clock cycle");
		jp.add(label, c0);
		
		c0.gridwidth = 1;
		label = new JLabel("HIGH to LOW mode:");
		jp.add(label, c0);
		pcInHighToLowMode = new JTextField("160", 20);
		jp.add(pcInHighToLowMode, c0);
		c0.gridwidth = GridBagConstraints.REMAINDER; //end row
		label = new JLabel("pw / clock cycle");
		jp.add(label, c0);
		
		c0.gridwidth = 1;
		label = new JLabel("HIGH mode:");
		jp.add(label, c0);
		pcInHighMode = new JTextField("200", 20);
		jp.add(pcInHighMode, c0);
		c0.gridwidth = GridBagConstraints.REMAINDER; //end row
		label = new JLabel("pw / clock cycle");
		jp.add(label, c0);
		
		panel2.add(jp, BorderLayout.SOUTH);
		
		jp1.add(panel2, BorderLayout.SOUTH);*/
		
        framePanel.add(panel2, BorderLayout.CENTER);
        
        pack();
    }
    
    public void actionPerformed(ActionEvent evt)  {
        //String command = evt.getActionCommand();
        //System.out.println("Command:" + command);
        
        if (evt.getSource() == close) {
        		opened --;
        		matchSelected = caseNonDependent.isSelected();
        		dispose();
            return;
        } 
    }
	
	
    
	
    
} // Class